package fr.irisa.cairn.jnimap.generator.java;

import fr.irisa.cairn.jniMap.Mapping;
import fr.irisa.cairn.jniMap.PtrType;
import fr.irisa.cairn.jnimap.generator.CommonExtensions;
import fr.irisa.cairn.jnimap.generator.TypeExtensions;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.xbase.lib.Extension;

@SuppressWarnings("all")
public class PointerWrapperExtension {
  @Extension
  private CommonExtensions _commonExtensions = new CommonExtensions();
  
  @Extension
  private TypeExtensions _typeExtensions = new TypeExtensions();
  
  public CharSequence pointerMappingContent(final PtrType pt, final Mapping m) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("/**");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*  Automatically generated by jnimap ");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*/");
    _builder.newLine();
    _builder.append("package ");
    String _packageName = this._commonExtensions.packageName(m);
    _builder.append(_packageName);
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("public class ");
    String _standardJavaName = this._typeExtensions.standardJavaName(pt);
    _builder.append(_standardJavaName);
    _builder.append(" {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("public ");
    String _standardJavaName_1 = this._typeExtensions.standardJavaName(pt.getBase());
    _builder.append(_standardJavaName_1, "\t");
    _builder.append(" value;");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("\t");
    _builder.append("/*** PROTECTED REGION ID(");
    String _standardJavaName_2 = this._typeExtensions.standardJavaName(pt);
    _builder.append(_standardJavaName_2, "\t");
    _builder.append("_userCode) ENABLED START ***/");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("/*");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("Put you user code here !");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.newLine();
    _builder.append("\t \t");
    _builder.append("*/");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("/*** PROTECTED REGION END ***/");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
}
